//=========================================================
//  MusE
//  Linux Music Editor
//  $Id: alsatimer.h,v 1.1.2.1 2004/11/26 21:14:13 spamatica Exp $
//
//  Plenty of code borrowed from timer.c example in 
//  alsalib 1.0.7
//
//  (C) Copyright 2004 Robert Jonsson (rj@spamatica.se)
//=========================================================

#ifndef __ALSATIMER_H__
#define __ALSATIMER_H__

#include "alsa/asoundlib.h"
#include "timerdev.h"


//---------------------------------------------------------
//   AlsaTimer
//---------------------------------------------------------

class AlsaTimer : public Timer{
    
    snd_timer_t *handle;
    snd_timer_id_t *id;
    snd_timer_info_t *info;
    snd_timer_params_t *params;
    struct pollfd *fds;
    char timername[64];
    int count;
    int ticks;


    public:
       AlsaTimer();
       virtual ~AlsaTimer();
       
       virtual int initTimer();
       virtual bool setTimerResolution(int resolution);
       virtual int  getTimerResoltution();
       virtual bool setTimerTicks(int tick);
       
       virtual bool startTimer();
       virtual bool stopTimer();
       virtual unsigned long getTimerTicks();
       
};

#endif //__ALSATIMER_H__
